<?php
//------------------------------------------------------------------------------
// SimpleChat v2.0b [18.01.2009]
// Простой чат для phpBB 3 в стиле чата сайта delphimaster.ru
// Copyright 2009 Evgeny Vrublevsky <veg@tut.by>
//------------------------------------------------------------------------------

define("IN_PHPBB", true);
$phpbb_root_path = './../';
$phpbb_chat_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
header("cache-control: no-cache, must-revalidate");

// Инициализация
$user->session_begin();
$auth->acl($user->data);
$user->setup();
$user->set_custom_lang_path($phpbb_chat_path.'language');
$user->add_lang('chat');
$user->set_custom_lang_path($phpbb_root_path . 'language'); // Необходимо для некоторых модов

// Таблицы
define('CHAT_MESSAGES_TABLE',	$table_prefix . 'chat_messages');
define('CHAT_SESSIONS_TABLE',	$table_prefix . 'chat_sessions');
// Время жизни сессии
define('SESSION_LIFE', 	90);
// Статусы
define('STATUS_ONLINE',	0); // Доступен
define('STATUS_CHAT',	1); // Хочу початиться
define('STATUS_AWAY',	2); // Отсутствую
define('STATUS_DND',	3); // Не беспокоить
// Действия
define('ACT_LOAD', 	'load');
define('ACT_SYNC', 	'sync');
define('ACT_SAY',	'say');
// Специальные сообщения
define('MSG_JOIN',	'/hello');
define('MSG_LEFT',	'/bye');
// Внутренняя версия
define("COPYRIGHT", "Powered by SimpleChat v2.0 © 2009 <a target='_blank' href='http://veg.slutsk.net/'>Evgeny Vrublevsky</a>");
define("BUILD_TIME", filemtime(__FILE__));

$action = request_var('action', ACT_LOAD);
header("content-type: text/" . (($action == ACT_LOAD)?"html":"javascript") . "; charset=UTF-8");
// Проверяем внутреннюю версию клиента и скрипта
if($action != ACT_LOAD && request_var('build', BUILD_TIME) != BUILD_TIME)
{
	echo("FullReset();");
	exit;
}
// Проверка авторизации
if (!$user->data['is_registered'])
{
	if($action!=ACT_LOAD) echo("FullReset();");
	else login_box('', $user->lang['LOGIN_EXPLAIN_CHAT']);
	exit;
}
// Проверка бана
/*if($chat_session['user_status']==STATUS_BANNED)
{
	if($action!=ACT_LOAD) echo("FullReset();");
	else trigger_error($user->lang['CHAT_BANNED']);
	exit;
}*/

// Помечаем тех кто ушел
$die_time = time() - SESSION_LIFE;
$sql = "SELECT *
	FROM " . CHAT_SESSIONS_TABLE . " 
	WHERE last_active < '{$die_time}'
	ORDER BY last_active";
$result = $db->sql_query($sql);
while ($row = $db->sql_fetchrow($result))
{
	// Сообщение что ушел пользователь
	$message = array(
		'user_id'	=> $row['user_id'],
		'username'	=> $row['username'],
		'time'		=> $row['last_active'] + SESSION_LIFE,
		'text'		=> MSG_LEFT,
		'color'		=> '000000'
	);
	$sql = "INSERT INTO " . CHAT_MESSAGES_TABLE . " " . $db->sql_build_array('INSERT', $message);
	$db->sql_query($sql);	
}
// Удаляем ушедших
$sql = "DELETE 
	FROM " . CHAT_SESSIONS_TABLE . " 
	WHERE last_active < '{$die_time}'";
$db->sql_query($sql);

// Создаем новую или продлеваем старую сессию
$sql = 'SELECT *
	FROM ' . CHAT_SESSIONS_TABLE . '
	WHERE user_id = ' . (int)$user->data['user_id'];
$result = $db->sql_query($sql);
$chat_session = $db->sql_fetchrow($result);
$db->sql_freeresult($result);
if(!$chat_session)
{
	// Добавляем если надо нового юзера
	$chat_session = array(
		'user_id'		=> $user->data['user_id'],
		'username'		=> $user->data['username'],
		'last_active'	=> time(), // если бан - то время разбана, иначе время последнего обновления
		'user_status'	=> STATUS_ONLINE,
		'user_activity'	=> 0,
		'user_blocked'	=> 0
	);
	$sql = 'INSERT INTO ' . CHAT_SESSIONS_TABLE . ' ' .	$db->sql_build_array('INSERT', $chat_session);
	$db->sql_query($sql);
	// Сообщение что зашел новый пользователь
	$message = array(
		'user_id'	=> $user->data['user_id'],
		'username'	=> $user->data['username'],
		'time'		=> time(),
		'text'		=> MSG_JOIN,
		'color'		=> '000000'
	);
	$sql = "INSERT INTO " . CHAT_MESSAGES_TABLE . " " . $db->sql_build_array('INSERT', $message);
	$db->sql_query($sql);
}
else
{
	// Обновляем время последней активности и необходимость блокировки
	$chat_session['user_activity'] -= time() - $chat_session['last_active'];
	if($chat_session['user_activity'] < 0) $chat_session['user_activity'] = 0;
	if(!$chat_session['user_blocked'] && $action == ACT_SAY)
	{
		$chat_session['user_activity']+=3;
		if($chat_session['user_activity'] > 9)
		{
			$chat_session['user_activity'] = 30; // секунд блокировки
			$chat_session['user_blocked'] = 1;
		}
	}
	if($chat_session['user_activity'] == 0)
	{
		$chat_session['user_blocked'] = 0;
	}
	$chat_session['last_active'] = time();
	$sql = 'UPDATE ' . CHAT_SESSIONS_TABLE . '
		SET ' . $db->sql_build_array('UPDATE', $chat_session) . '
		WHERE user_id = ' . $user->data['user_id'];
	$db->sql_query($sql);
}

// Обрабатываем команды
switch ($action)
{
	// Загрузка HTML кода чата
	case ACT_LOAD:
		include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
		page_header($user->lang['CHAT']);
		$template->set_custom_template($phpbb_chat_path.'template', 'simplechat');
		$template->set_filenames(array('body' => 'chat_body.html'));
		$template->assign_vars(array(
			'COPYRIGHT' 	=> COPYRIGHT,
			'BUILD_TIME' 	=> BUILD_TIME
		));
		generate_smilies("inline", false);
		page_footer();
		exit;

	// Добавление нового сообщения
	case ACT_SAY:
		if($chat_session['user_blocked'])
		{
			$time = date("H:i", time());
			$name = "";
			// "Вы заблокированы из-за флуда. Бан: 30 сек."
			$text = sprintf($user->lang['CHAT_BLOCKED'], $chat_session['user_activity']);
			echo("LogMessage(0,'$time','$name','$text','000000');\n");
			exit;
		}
		$text = trim(utf8_normalize_nfc(request_var('text', '', true)));
		// Длина фразы не более 255
		if(utf8_strlen($text) > 255) $text = utf8_substr($text, 0, 255);
		$color	= request_var('color', '000000');
		if (!preg_match('#^[0-9a-f]{6}$#', $color)) $color = '000000';
		if($text!='')
		{
			$message = array(
				'user_id'	=> $user->data['user_id'],
				'username'	=> $user->data['username'],
				'time'		=> time(),
				'text'		=> $text,
				'color'		=> $color
			);
			$sql = "INSERT INTO " . CHAT_MESSAGES_TABLE . " " . $db->sql_build_array('INSERT', $message);
			$db->sql_query($sql);
		}
		exit;

	// Обновление состояния чата
	case ACT_SYNC:
		include($phpbb_root_path . 'includes/message_parser.' . $phpEx);
		// Выводим список пользователей
		$sql = "SELECT * FROM " . CHAT_SESSIONS_TABLE; // . " WHERE status != " . STATUS_HIDDEN;
	    $result = $db->sql_query($sql);
		$json = '[';
		while ($row = $db->sql_fetchrow($result))
		{
			if($json!='[') $json .= ',';
			$json .= '{id: '.$row['user_id'].', name: "'.addslashes($row['username']).'", status: '.$row['user_status'].'}';
		}
		$json .= ']';
		echo("SetUsers($json);\n");
		// Выводим новые сообщения
		$last_id = request_var('lastid', 0);
		$sql = "SELECT * 
			FROM " . CHAT_MESSAGES_TABLE . " 
			WHERE msg_id > " . $last_id . " 
			ORDER BY msg_id";
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			if($row['msg_id'] > $last_id) $last_id = $row['msg_id'];
			$msg_id = $row['msg_id'];
			$username = addslashes($row['username']);
			$user_id = $row['user_id'];
			$color = addslashes($row['color']);
			$time = addslashes(date("H:i", $row['time']));

			$text = trim($row['text']);
			if($text == MSG_JOIN)
			{
				echo("LogUserJoin($msg_id, '$time', '$username');\n");
				continue;
			}
			if($text == MSG_LEFT)
			{
				echo("LogUserLeft($msg_id, '$time', '$username');\n");
				continue;
			}
			// Обрабатываем приваты в строке
			$show = true;
			if( utf8_substr($text, 0, utf8_strlen("private ["))=="private [" )
			{
				$show = false;
				$tmp = $text;
				while(utf8_strpos($tmp, "private [")===0)
				{
					$endp = utf8_strpos($tmp, "]");
					$to = str_replace("private [", "", utf8_substr($tmp, 0, $endp));
					if($to == $user->data['username']) $show = true;
					$tmp = trim(utf8_substr($tmp, $endp+1));
				}
				$msgpriv = trim(utf8_substr($text, 0, utf8_strlen($text)-utf8_strlen($tmp)));
				$text = "<span class=\"private\">" . $msgpriv . "</span> " . $tmp;
			}
			if((!$show) && ($user->data['username'] != $row['username']) ) continue;
			// Парсим смайлики и ссылки в сообщениях больше 1
			if(utf8_strlen($text)>1)
			{
				$message_parser = new parse_message($text); // "0" воспринимает как NULL
				$message_parser->magic_url(false);
				$message_parser->smilies(0);
				$text = (string) $message_parser->message;
				unset($message_parser);
				$text = str_replace("<a ", "<a target='_blank' ", $text); // Ссылки в новом окне
				$text = str_replace("{SMILIES_PATH}", "{$phpbb_root_path}{$config['smilies_path']}", $text);
			}
			$text = str_replace("to [".$user->data['username']."]", "<span class=\"to\">to [".$user->data['username']."]</span>", $text);
			$text = addslashes($text);
			echo("LogMessage($msg_id, '$time', '$username', '$text', '$color');\n");
		}
		echo("SetLastId($last_id);\n");
		// Удаляем устаревшие сообщения
		$sql = "DELETE FROM " . CHAT_MESSAGES_TABLE . " WHERE msg_id < " . ($last_id - 30);
		$db->sql_query($sql);
		exit;
}
?>